mscorlib [00 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00] 1.0.5000.0 2.0.0.0 Gtk# is thread aware, but not thread safe; See the <link location="node:gtk-sharp/programming/threads">Gtk# Thread Programming</link> for details. System.Security.Cryptography.DeriveBytes Implement PKCS #5 (Password-Based Cryptography Standard) password-based key derivation.

Mono implements only PKCS#5 v1.5 in this class. On Microsoft's runtime the constructors and methods using CspParameters can be used to select a specific CSP for key derivation. The problem is that the "standard" MS CSP key derivation is undocumented and non-MS CSP may use different implementations as well.

Using an undocumented key derivation algorithm for your product is a REALLY BAD idea.

WARNING: See method for more informations about the security and interoperability issues when using this class.

FX 2.0: Unless you must interoperate with PKCS#5 v.1.5 please use the newer Rfc2898DeriveBytes class which implements PKCS#5 v2.0.

- Constructor
  To be added.
  To be added.
  To be added.
  To be added.
  2.0.0.0
- Constructor
  The password to be converted into a secret key.
  A salt (public random value) to be added to the derivation. This parameter helps to prevent pre-calculated dictionary attacks against the algorithm.
  Create a new instance of PasswordDeriveBytes with a secret password and a salt value.
  To be added
  1.0.5000.0
  2.0.0.0
- Constructor
  To be added.
  To be added.
  To be added.
  To be added.
  To be added.
  2.0.0.0
- Constructor
  The password to be converted into a secret key.
  A salt (public random value) to be added to the derivation. This parameter helps to prevent pre-calculated dictionary attacks against the algorithm.
  Parameters to select a Cryptographic Service Provider (CSP) to derive the bytes.
  Create a new instance of PasswordDeriveBytes with a secret password and a salt value to be used with the specified CSP.
  This constructor will always throw a because Mono doesn't support the Cryptographic Service Provider (CSP) to derive new secret keys.
  1.0.5000.0
  2.0.0.0
- Constructor
  To be added.
  To be added.
  To be added.
  To be added.
  To be added.
  To be added.
  2.0.0.0
- Constructor
  The password to be converted into a secret key.
  A salt (public random value) to be added to the derivation. This parameter helps to prevent pre-calculated dictionary attacks against the algorithm.
  The hash algorithm name to be used to derive new bytes.
  The number of iterations done by the algorithm before returning any bytes.
  Create a new instance of PasswordDeriveBytes with a secret password, a salt value, a hash algorithm and an iteration count.
  To be added
  1.0.5000.0
  2.0.0.0
- Constructor
  To be added.
  To be added.
  To be added.
  To be added.
  To be added.
  To be added.
  To be added.
  2.0.0.0
- Constructor
  The password to be converted into a secret key.
  A salt (public random value) to be added to the derivation. This parameter helps to prevent pre-calculated dictionary attacks against the algorithm.
  The hash algorithm name to be used to derive new bytes.
  The number of iterations done by the algorithm before returning any bytes.
  Parameters to select a Cryptographic Service Provider (CSP) to derive the bytes.
  Create a new instance of PasswordDeriveBytes with a secret password, a salt value, a hash algorithm and an iteration count to be used with the specified CSP.
  This constructor will always throw a because Mono doesn't support the Cryptographic Service Provider (CSP) to derive new secret keys.
  1.0.5000.0
  2.0.0.0
- Method
  System.Byte[] `` `` `` `` To be added: an object of type 'string' To be added: an object of type 'string' To be added: an object of type 'int' To be added: an object of type 'byte []' Use the key derivation algorithm provided by the specified Cryptographic Service Provider (CSP). An array of the specified length contaning bytes derived of the secret password and other (possibly public) informations. This method isn't supported by Mono and will always throw a . 1.0.5000.0 2.0.0.0
- Method
  System.Void To be added Internal state of the algorithm will be zeroized. 1.0.5000.0 2.0.0.0
- Method
  System.Byte[] `` The length of derived bytes requested. Request a buffer of derived bytes from the algorithm. An array of the specified length contaning bytes derived of the secret password and other (possibly public) informations.

  SECURITY WARNING: You should never ask for more bytes than the digest algorithm can provide (e.g. 20 bytes maximum for SHA-1). This is the maximum you can get securely (i.e. don't try to get a 256 bits key using SHA-1). The PKCS#5 specification dictates to return an error if more is asked, however MS implementation does support it.

  INTEROPERABILITY WARNING: The previous undocumented behaviour isn't 100% compatible between Mono and MS implementation and should be avoided when possible. If it cannot be avoided try to call GetBytes once then split the bytes amongst multiple variables (e.g. key, iv) if required. This seems to be the safest way to interoperate between the two implementations.

  1.0.5000.0
  2.0.0.0
  System.Obsolete("see Rfc2898DeriveBytes for PKCS#5 v2 support")
- Property
  System.String The hash algorithm name to be used to derive new bytes. The current hash algorithm used to derive bytes. Default hash algorithm is and can provide, securely, up to 20 bytes of data. 1.0.5000.0 2.0.0.0
- Property
  System.Int32 The number of iterations done by the algorithm before returning any bytes. The current iteration count.

  This value can be ajusted to a balance so deriving a single key from a password is relatively fast (normal use) but very slow to use multiple times (e.g. attackers using a dictionary or a brute force attack). This makes the derivation algorithm stays "current" with newer and faster computer.

  Interoperability warning: The default iteration count is 1 to be compatible with Microsoft implementation. However this value is too low to be secure. Many other implementations use 1000 or 1024.

  1.0.5000.0
  2.0.0.0
- Method
  System.Void Reset the algorithm state to it's original state. The next call to GetBytes will be identical to the first call. 1.0.5000.0 2.0.0.0
- Property
  System.Byte[] A salt (public random value) to be added to the derivation. The current salt value being used to derive bytes. The salt value helps to prevent pre-calculated dictionary attacks against the algorithm. 1.0.5000.0 2.0.0.0
System.Runtime.InteropServices.ComVisible(true)